<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<jcr:propertyInitializers var="countries" nodeType="fcnt:countryListDefinition" name="country"/>

<div id="<@= id @>" class="control-group">
    <label class="control-label" for="<@= id @>_block_<@= address1_id @>">
        <@= label @>
    </label>
    <div class="controls">
        <input type="hidden" value="address" name="<@= id @>_block_<@= rendererName_id @>">
        <input id="<@= address1_id @>" name="<@= id @>_block_<@= address1_id @>" type="text" placeholder="<@= address1placeholder @>"
        <@ if(validations != undefined && validations.address) { @> required="required" <@ } @> >
        <span id="<@= id @>_block_<@= address1_id @>" class="hide help-inline"></span>
    </div>
    <div class="controls" style="margin-top: 10px;">
        <input id="<@= address2_id @>" name="<@= id @>_block_<@= address2_id @>" type="text" placeholder="<@= address2placeholder @>">
    </div>
    <div class="controls controls-row" style="margin-top: 10px;">
        <input id="<@= zipcode_id @>" name="<@= id @>_block_<@= zipcode_id @>" type="text" placeholder="<@= zipcodeplaceholder @>" class="input-mini"
        <@ if(validations != undefined && validations.address) { @> required="required" <@ } @> >
        <input id="<@= city_id @>" name="<@= id @>_block_<@= city_id @>" type="text" placeholder="<@= cityplaceholder @>" style="width: 130px;"
        <@ if(validations != undefined && validations.address) { @> required="required" <@ } @> >
        <span id="<@= id @>_block_<@= zipcode_id @>" class="hide help-inline"></span>
        <span id="<@= id @>_block_<@= city_id @>" class="hide help-inline"></span>
    </div>
    <div class="controls controls-row" style="margin-top: 10px;">
        <select id="<@= country_id @>" name="<@= id @>_block_<@= country_id @>" style="width: 144px;"
        <@ if(validations != undefined && validations.address) { @> required="required" <@ } @> >
        <option value=""><@= countryplaceholder @></option>
        <c:forEach items="${countries}" var="country">
            <option value='{"country":{"key":"${country.value.string}","name":"${country.displayName}"}}'>${country.displayName}</option>
        </c:forEach>
        </select>
        <input id="<@= state_id @>" name="<@= id @>_block_<@= state_id @>" type="text" placeholder="<@= stateplaceholder @>" class="input-mini">
        <@ if(validations != undefined) { @>
        <span id="<@= id @>_block_<@= country_id @>" class="hide help-inline"></span>
        <@ } @>
    </div>
    <div class="controls">
        <@ if (helptext.length > 0) { @>
        <p class="help-block"><@= helptext @></p>
        <@ } @>
    </div>
</div>
