<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="wf" uri="http://www.jahia.org/tags/workflow" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="formLibrary" type="org.jahia.modules.formfactory.webflow.model.Library"--%>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="admin-bootstrap.js"/>
<template:addResources type="javascript" resources="fcLibraryUtils.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js,jquery.blockUI.js,workInProgress.js"/>
<template:addResources type="javascript" resources="lib/bootbox.min.js"/>
<template:addResources type="javascript" resources="lib/moment.min.js"/>
<template:addResources type="javascript" resources="datatables/jquery.dataTables.js,datatables/dataTables.bootstrap-ext.js"/>
<template:addResources type="javascript" resources="i18n/jquery.dataTables-${renderContext.UILocale.language}.js"/>

<template:addResources type="css" resources="datatables/css/bootstrap-theme.css"/>
<template:addResources type="css" resources="languageSwitchingLinks.css"/>

<fmt:message key="fcnt_createEntry.error.formNameImpossibleToCheck" var="errorFormNameImpossibleToCheck"/>
<fmt:message key="fcnt_library.label.placeholderNewFormName" var="placeholderNewFormName"/>
<fmt:message key="fcnt_library.modal.deleteConfirmation" var="modalDeleteConfirmation"/>
<fmt:message key="fcnt_library.modal.undeleteConfirmation" var="modalUndeleteConfirmation"/>
<fmt:message key="fcnt_library.modal.nameForm" var="modalNameForm"/>
<fmt:message key="fcnt_library.modal.nameNewFormTemplate" var="modalNameNewFormTemplate"/>
<fmt:message key="fcnt_library.title.deleteConfirmation" var="titleDeleteConfirmation"/>
<fmt:message key="fcnt_library.title.undeleteConfirmation" var="titleUndeleteConfirmation"/>
<fmt:message key="fcnt_createEntry.title.nameForm" var="titleNameForm"/>
<fmt:message key="fcnt_library.title.nameNewFormTemplate" var="titleNameNewFormTemplate"/>
<fmt:message key="fcnt.dataTableNoResult" var="dataTableNoResult"/>
<fmt:message key="label.cancel" var="labelCancel"/>
<fmt:message key="label.no" var="labelNo"/>
<fmt:message key="label.ok" var="labelOk"/>
<fmt:message key="label.yes" var="labelYes"/>
<fmt:message key="label.workInProgressTitle" var="i18nWaiting"/>

<template:addResources type="inlinejavascript">
    <script>
        var urlContext = "${url.context}/";

        //Map with messages from resources bundle
        var jsVarMap = {
            checkFormNameURL : '<c:url value="${url.base}${renderContext.mainResource.node.path}.checkFormNameAvailability.do"/>',
            siteName: '${functions:escapeJavaScript(renderContext.site.name)}',
            errorFormNameImpossibleToCheck: '${functions:escapeJavaScript(errorFormNameImpossibleToCheck)}',
            modalDeleteConfirmation: '${functions:escapeJavaScript(modalDeleteConfirmation)}',
            modalUndeleteConfirmation: '${functions:escapeJavaScript(modalUndeleteConfirmation)}',
            modalNameForm: '${functions:escapeJavaScript(modalNameForm)}',
            modalNameNewFormTemplate: '${functions:escapeJavaScript(modalNameNewFormTemplate)}',
            titleDeleteConfirmation: '${functions:escapeJavaScript(titleDeleteConfirmation)}',
            titleUndeleteConfirmation: '${functions:escapeJavaScript(titleUndeleteConfirmation)}',
            titleNameForm: '${functions:escapeJavaScript(titleNameForm)}',
            titleNameNewFormTemplate: '${functions:escapeJavaScript(titleNameNewFormTemplate)}',
            dataTableNoResult: '${functions:escapeJavaScript(dataTableNoResult)}',
            labelCancel: '${functions:escapeJavaScript(labelCancel)}',
            labelNo: '${functions:escapeJavaScript(labelNo)}',
            labelOk: '${functions:escapeJavaScript(labelOk)}',
            labelYes: '${functions:escapeJavaScript(labelYes)}',
            i18nWaiting: '${functions:escapeJavaScript(i18nWaiting)}',
            uiLocale: '${renderContext.UILocale.language}'
        };
        moment.locale(['${renderContext.mainResourceLocale.language}','en']);

        $(document).ready(function () {
            var timeoutReference;
            $('#inputNameNewForm').keypress(function() {
                var _this = $(this);
                if (timeoutReference) clearTimeout(timeoutReference);
                timeoutReference = setTimeout(function() {
                    checkFormNameAvailableInJCR(_this.val());
                }, 1000);
            });
        });
    </script>
</template:addResources>
<c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
    <div class="alert <c:choose><c:when test="${message.severity eq 'ERROR'}">alert-error</c:when><c:otherwise>alert-success</c:otherwise></c:choose>">
        <button type="button" class="close" data-dismiss="alert">&times;</button>
            ${message.text}
    </div>
</c:forEach>
<div class="row-fluid">
    <div class="clearfix">
        <h1 class="pull-left"><fmt:message key="fcnt_library.title.createNewForm"/></h1>
        <div class="pull-right">
            <img alt="" src="<c:url value="${url.currentModule}/img/form-factory.png"/>">
        </div>
    </div>
    <div class="alert alert-info">
        <label class="control-label">
            <fmt:message key="fcnt_library.label.form"/>
        </label>
        <input id="inputNameNewForm" type="text" placeholder="${functions:escapeJavaScript(placeholderNewFormName)}"/>
        <button id="createNewForm" type="button" class="btn btn-primary" disabled="disabled" onclick="submitNewForm()">
            <fmt:message key="fcnt_library.button.create"/>
            <i class="icon-chevron-right icon-white"></i>
        </button>
        <div class="hide text-error" id="error_nameNewFormAvailability"></div>
    </div>
</div>

<div class="row-fluid">
    <h1><fmt:message key="fcnt_library"/></h1>
    <form:form name="formManagement" class="manageForms form box-1" action="${flowExecutionUrl}" method="post"
               modelAttribute="formLibrary">
        <input id="eventInput" name="_eventId_" type="hidden"/>
        <input type="hidden" id="selectedForm" name="selectedForm"/>
        <input type="hidden" id="nameNewForm" name="nameNewForm"/>

        <table class="table table-bordered" id="myFormsDataTable">
            <thead>
            <tr>
                <th style="vertical-align: middle;min-width: 200px;"><fmt:message key="label.name"/></th>
                <c:if test="${functions:length(renderContext.site.activeLiveLanguagesAsLocales) gt 1}">
                    <th style="vertical-align: middle;min-width: 200px;"><fmt:message key="label.languages"/></th>
                </c:if>
                <th style="vertical-align: middle;"><fmt:message key="label.created"/></th>
                <th style="vertical-align: middle;"><fmt:message key="fcnt_library.button.chooseActions"/></th>
            </tr>
            </thead>
            <tbody>
            <c:forEach var="form" items="${formLibrary.formsList}">
                <jcr:node var="formNode" uuid="${form.jcrId}"/>
                <c:set var="isMarkedForDeletion" value="${jcr:isNodeType(formNode, 'jmix:markedForDeletion')}"/>
                <tr>
                    <td style="vertical-align: middle;">
                        <dl>
                            <dt><c:if test="${isMarkedForDeletion}"><del></c:if>${form.formName}<c:if test="${isMarkedForDeletion}"></del></c:if>&nbsp;<c:choose><c:when test="${wf:hasActivePublicationWorkflow(formNode)}"><img src="${url.context}/icons/publication/locked.png"/></c:when><c:when test="${not formNode.properties['j:published'].boolean}"><img src="${url.context}/icons/publication/notpublished.png"/></c:when><c:when test="${jcr:needPublication(formNode, renderContext.mainResourceLocale, false, true, true)}"><img src="${url.context}/icons/publication/modified.png"/></c:when><c:otherwise><img src="${url.context}/icons/publication/published.png"/></c:otherwise></c:choose></dt>
                            <dd>${form.formDescription}</dd>
                        </dl>
                    </td>
                    <c:if test="${functions:length(renderContext.site.activeLiveLanguagesAsLocales) gt 1}">
                        <td style="text-align: left; vertical-align: middle;">
                            <dl class="dl-horizontal">
                                <dt><fmt:message key="building.language"/></dt>
                                <dd data-toggle="tooltip" title="<fmt:message key="building.language.description"/>"><ul class="inline"><li><span class="flag ${functions:getLanguageFlagCSSClass(functions:toLocale(form.buildingLang))}"/></li></ul></dd>
                                <dt><fmt:message key="translated.languages"/></dt>
                                <dd data-toggle="tooltip" title="<fmt:message key="translated.languages.description"/>"><ul class="inline">
                            <c:forEach items="${form.existingLanguagesAsLocale}" var="lang">
                                <c:if test="${functions:toLocale(form.buildingLang) ne lang}">
                                    <li><span class="flag ${functions:getLanguageFlagCSSClass(lang)}"/></li>
                                </c:if>
                            </c:forEach>
                            </ul>
                                </dd>
                                </dl>
                        </td>
                    </c:if>
                    <td style="text-align: left; vertical-align: middle;">
                        <span class="timeago">${form.created}</span>
                    </td>
                    <td style="text-align: left; vertical-align: middle;">
                        <div class="btn-group">
                            <c:choose>
                                <c:when test="${isMarkedForDeletion}">
                                    <c:choose>
                                        <c:when test="${not formNode.properties['j:published'].boolean}">
                                            <button type="button" class="btn" id="reallyDeleteButton"
                                                    onclick="bbDeleteForm('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}');">
                                                <i class="icon-trash"></i>
                                                <fmt:message key="label.deletePermanently"/>
                                            </button>
                                        </c:when>
                                        <c:otherwise>
                                            <fmt:message key="label.deletePermanently" var="rbPublish"/>
                                            <wf:workflowsForNode var="availableWorkflows" node="${formNode}"
                                                                 checkPermission="true"
                                                                 locale="${renderContext.mainResourceLocale}"
                                                                 workflowAction="publish"/>
                                            <c:forEach items="${availableWorkflows}" var="availableWorkflow">
                                                <c:set var="title">${rbPublish}&nbsp;-&nbsp;${availableWorkflow.displayName}</c:set>
                                                <button  type="button" class="btn" onclick="startWorkflowOnForm('${form.jcrId}')"
                                                   data-toggle="tooltip" title="${title}">
                                                    <i class="icon-share"></i>${functions:abbreviate(title,15,40,'...')}
                                                </button>
                                            </c:forEach>
                                        </c:otherwise>
                                    </c:choose>
                                </c:when>
                                <c:when test="${wf:hasActivePublicationWorkflow(formNode)}">
                                    <button type="button" class="btn" id="asTemplateButton"
                                            onclick="bbUseAsTemplate('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}');">
                                        <i class="icon-share-alt"></i>
                                        <fmt:message key="fcnt_library.button.useAsTemplate"/>
                                    </button>
                                </c:when>
                                <c:when test="${functions:toLocale(form.buildingLang) eq renderContext.mainResourceLocale}">
                                    <button type="button" class="btn" id="modifyButton"
                                            onclick="loadFormToUpdate('${form.jcrId}')">
                                        <i class="icon-edit"></i>
                                        <fmt:message key="fcnt_library.button.modify"/>
                                    </button>
                                </c:when>
                                <c:otherwise>
                                    <button type="button" class="btn" id="translateButton"
                                            onclick="loadFormToTranslate('${form.jcrId}')">
                                        <i class="icon-edit"></i>
                                        <fmt:message key="fcnt_library.button.translate"/>
                                    </button>
                                </c:otherwise>
                            </c:choose>
                            <c:if test="${not wf:hasActivePublicationWorkflow(formNode)}">
                            <button class="btn dropdown-toggle" data-toggle="dropdown">
                                <span class="caret"></span>
                            </button>
                            <ul class="dropdown-menu" style="text-align: left;">
                                    <c:choose>
                                        <c:when test="${((not isMarkedForDeletion) or formNode.properties['j:published'].boolean) and jcr:needPublication(formNode, renderContext.mainResourceLocale, false, true, true)}">
                                            <li>
                                                <c:choose>
                                                    <c:when test="${isMarkedForDeletion}"><fmt:message key="label.deletePermanently" var="rbPublish"/></c:when>
                                                    <c:otherwise><fmt:message key="label.publish" var="rbPublish"/></c:otherwise>
                                                </c:choose>
                                                <wf:workflowsForNode var="availableWorkflows" node="${formNode}"
                                                                     checkPermission="true"
                                                                     locale="${renderContext.mainResourceLocale}"
                                                                     workflowAction="publish"/>
                                                <c:forEach items="${availableWorkflows}" var="availableWorkflow">
                                                    <c:set var="title">${rbPublish}&nbsp;-&nbsp;${availableWorkflow.displayName}</c:set>
                                                    <a onclick="startWorkflowOnForm('${form.jcrId}')"
                                                       data-toggle="tooltip" title="${title}">
                                                        <i class="icon-share"></i>${functions:abbreviate(title,15,40,'...')}
                                                    </a>
                                                </c:forEach>
                                                <c:if test="${jcr:hasPermission(formNode, 'publish')}">
                                                    <fmt:message key="label.bypassWorkflow" var="rbBypass"/>
                                                    <c:set var="title">${rbPublish}&nbsp;-&nbsp;${rbBypass}</c:set>
                                                    <a onclick="publishForm('${form.jcrId}')" data-toggle="tooltip"
                                                       title="${title}">
                                                        <i class="icon-share"></i>${functions:abbreviate(title,15,40,'...')}
                                                    </a>
                                                </c:if>
                                            </li>
                                        </c:when>
                                    </c:choose>
                                <c:if test="${not isMarkedForDeletion}">
                                <li>
                                    <a onclick="loadFormToEditMetaData('${form.jcrId}');">
                                        <i class="icon-edit"></i>
                                        <fmt:message key="fcnt_library.button.editMetaData"/>
                                    </a>
                                </li>
                                <li>
                                    <a onclick="bbUseAsTemplate('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}');">
                                        <i class="icon-share-alt"></i>
                                        <fmt:message key="fcnt_library.button.useAsTemplate"/>
                                    </a>
                                </li>
                                    <jcr:node var="actionsNode" path="${formNode.path}/actions"/>
                                    <c:if test="${not empty actionsNode}">
                                        <c:forEach items="${jcr:getChildrenOfType(actionsNode, 'fcmix:action')}"
                                                   var="actionNode">
                                            <jcr:node var="trNode"
                                                      path="${actionNode.path}/j:translation_${renderContext.mainResourceLocale}"/>
                                            <c:if test="${not empty trNode}">
                                                <c:set var="i18nNode" value="${trNode}"/>
                                            </c:if>
                                        </c:forEach>
                                        <c:if test="${not empty i18nNode}">
                                            <li>
                                                <a onclick="bbDuplicateUseAsTemplate('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}');">
                                                    <i class="icon-share-alt"></i>
                                                    <fmt:message key="fcnt_library.button.duplicateUseAsTemplate"/>
                                                </a>
                                            </li>
                                        </c:if>
                                        <c:remove var="i18nNode"/>
                                        <c:remove var="actionsNode"/>
                                        <c:remove var="trNode"/>
                                    </c:if>
                                </c:if>
                                <c:choose>
                                    <c:when test="${isMarkedForDeletion}">
                                        <li>
                                            <a onclick="bbUndeleteForm('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}')">
                                                <i class="icon-trash"></i>
                                                <span class="text-error"><fmt:message key="label.undelete"/></span>
                                            </a>
                                        </li>
                                    </c:when>
                                    <c:when test="${jcr:hasPermission(formNode, 'jcr:all_default')}">
                                        <li>
                                            <a onclick="bbMarkToDeleteForm('${form.jcrId}', '${functions:escapeJavaScript(form.formName)}')">
                                                <i class="icon-trash"></i>
                                                <span class="text-error"><fmt:message key="label.delete"/></span>
                                            </a>
                                        </li>
                                    </c:when>
                                </c:choose>
                            </ul>
                        </div>
                        </c:if>
                    </td>
                </tr>
            </c:forEach>
            </tbody>
        </table>
    </form:form>
</div>