<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="currentForm" type="org.jahia.modules.formfactory.webflow.model.Form"--%>

<template:addResources type="css" resources="datatables/css/bootstrap-theme.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="lib/underscore.js"/>
<template:addResources type="javascript"
                       resources="datatables/jquery.dataTables.js,datatables/dataTables.bootstrap-ext.js,i18n/jquery.dataTables-${currentResource.locale.language}.js"/>

<jcr:node var="formTest" path=""/>
<template:addResources type="inlinejavascript">
    <script>
        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };

        $(document).ready(function () {
            var formJson = ${currentForm.json};

            var _dataTableTemplate = _.template("<tr><td><@= label @></td><td><@= value @></td></tr>");
            _.each(${currentForm.jsonResults}, function(vResult, kResult) {
                _.each(formJson.formSteps, function(step) {
                    _.each(step.stepContent, function(snippet) {
                        if (snippet.fields.id.value == kResult) {
                            $('#tableBody').append(_dataTableTemplate({label: snippet.fields.label.value, value: vResult}));
                        }
                    });
                });
            });

            var _actionResultMessageTemplate = _.template("<li><@= message @></li>");
            _.each(${currentForm.jsonActionResult}, function(actionResult) {
                if (actionResult.status == "success") {
                    $("#successList").append(_actionResultMessageTemplate({message: actionResult.message}));
                    if ($("#success").hasClass("hide")) {
                        $("#success").show();
                    }
                } else {
                    $("#errorList").append(_actionResultMessageTemplate({message: actionResult.message}));
                    if ($("#error").hasClass("hide")) {
                        $("#error").show();
                    }
                }
            });

            $('#result_table').dataTable({
                "sDom": "<'row-fluid'<'span6'l><'span6'f>r>t<'row-fluid'<'span6'i><'span6'p>>",
                "iDisplayLength": 25,
                "sPaginationType": "bootstrap",
                "aaSorting": [], //this option disable sort by default, the user steal can use column names to sort the table
                "oLanguage": {
                    "sEmptyTable": "<fmt:message key="fcnt.dataTableNoResult"/>"
                }
            });
        });
    </script>
</template:addResources>

<div class="row-fluid clearfix">
    <!-- Form. -->
    <h2>${currentForm.formName}</h2>
    <div id="success" class="resultMessages alert alert-success hide" style="margin-top:20px;margin-bottom:20px;">
        <ul id="successList"></ul>
    </div>
    <div id="error" class="resultMessages alert alert-error hide" style="margin-top:20px;margin-bottom:20px;">
        <ul id="errorList"></ul>
    </div>
    <div id="submitResult">
        <h4><fmt:message key="fcnt_formSubmitted.title.submittedInformation" /></h4>
        <table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered"
               id="result_table">
            <thead>
            <tr>
                <th style="text-align:center"><fmt:message key="fcnt_formSubmitted.label.formField"/></th>
                <th style="text-align:center"><fmt:message key="fcnt_formSubmitted.label.answer"/></th>
            </tr>
            </thead>
            <tbody id="tableBody">
            </tbody>
        </table>
    </div>
</div>
