<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<template:addCacheDependency flushOnPathMatchingRegexp="\\\\Q${currentNode.path}\\\\E/.*"/>
<jcr:node path="${currentNode.path}/message" var="nodeRangeLengthMessage"/>
<jcr:node path="${currentNode.path}/rangelengthmin" var="nodeRangeLengthMin"/>
<jcr:node path="${currentNode.path}/rangelengthmax" var="nodeRangeLengthMax"/>

<c:set var="rangeLengthMin" value="${nodeRangeLengthMin.properties['jsonValue'].string}"/>
<c:set var="rangeLengthMax" value="${nodeRangeLengthMax.properties['jsonValue'].string}"/>
<c:set var="rangeLengthMessage" value="${nodeRangeLengthMessage.properties['jsonValue'].string}"/>

<c:choose>
    <c:when test="${(not empty rangeLengthMin) and (not empty rangeLengthMax) and not(rangeLengthMin eq rangeLengthMax)}">
        {
            rangeLength: [${rangeLengthMin},${rangeLengthMax}]
            <c:if test="${not empty rangeLengthMessage}">
                ,msg: '${functions:escapeJavaScript(rangeLengthMessage)}'
            </c:if>
        }
    </c:when>
    <c:when test="${(not empty rangeLengthMin) and (empty rangeLengthMax)}">
        {
            minLength: ${rangeLengthMin}
            <c:if test="${not empty rangeLengthMessage}">
                ,msg: '${functions:escapeJavaScript(rangeLengthMessage)}'
            </c:if>
        }
    </c:when>
    <c:when test="${(empty rangeLengthMin) and (not empty rangeLengthMax)}">
        {
            maxLength: ${rangeLengthMax}
            <c:if test="${not empty rangeLengthMessage}">
                ,msg: '${functions:escapeJavaScript(rangeLengthMessage)}'
            </c:if>
        }
    </c:when>
    <c:when test="${(not empty rangeLengthMin) and (not empty rangeLengthMax) and (rangeLengthMin eq rangeLengthMax)}">
        {
            length: ${rangeLengthMax}
            <c:if test="${not empty rangeLengthMessage}">
                ,msg: '${functions:escapeJavaScript(rangeLengthMessage)}'
            </c:if>
        }
    </c:when>
</c:choose>