<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<template:addCacheDependency flushOnPathMatchingRegexp="\\\\Q${currentNode.path}\\\\E/.*"/>
<jcr:node path="${currentNode.path}/message" var="nodeRangeMessage"/>
<jcr:node path="${currentNode.path}/rangemin" var="nodeRangeMin"/>
<jcr:node path="${currentNode.path}/rangemax" var="nodeRangeMax"/>

<c:set var="rangeMin" value="${nodeRangeMin.properties['jsonValue'].string}"/>
<c:set var="rangeMax" value="${nodeRangeMax.properties['jsonValue'].string}"/>
<c:set var="rangeMessage" value="${nodeRangeMessage.properties['jsonValue'].string}"/>

<c:choose>
    <c:when test="${(not empty rangeMin) and (not empty rangeMax)}">
        {
        range: [${rangeMin},${rangeMax}]
        <c:if test="${not empty rangeMessage}">
            ,msg: '${functions:escapeJavaScript(rangeMessage)}'
        </c:if>
        }
    </c:when>
    <c:when test="${(not empty rangeMin) and (empty rangeMax)}">
        {
        min: ${rangeMin}
        <c:if test="${not empty rangeMessage}">
            ,msg: '${functions:escapeJavaScript(rangeMessage)}'
        </c:if>
        }
    </c:when>
    <c:when test="${(empty rangeMin) and (not empty rangeMax)}">
        {
        max: ${rangeMax}
        <c:if test="${not empty rangeMessage}">
            ,msg: '${functions:escapeJavaScript(rangeMessage)}'
        </c:if>
        }
    </c:when>
</c:choose>
