<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="css" resources="datepicker.css"/>
<template:addResources type="css" resources="custom.css"/>

<template:addResources type="javascript" resources="lib/bootstrap-datepicker.js"/>
<template:addResources type="javascript" resources="lib/bootstrap-datepicker.${renderContext.UILocale}.js"/>
<template:addResources type="javascript" resources="fcResultsUtils.js"/>
<template:addResources type="javascript" resources="models/graphResult.js"/>
<template:addResources type="javascript" resources="lib/backbone.paginator.min.js"/>
<template:addResources type="javascript" resources="lib/chart.js"/>
<template:addResources type="javascript" resources="main-results.js"/>
<fmt:message key="fcnt_result.username" var="usernameHeader"/>
<fmt:message key="fcnt_result.submissionDate" var="subDateHeader"/>
<fmt:message key="fcnt_result.origin" var="originHeader"/>
<fmt:message key="fcnt_result.submissions.total" var="submissionsTotal"/>
<fmt:message key="fcnt_result.submissions.average" var="submissionsAverage"/>
<fmt:message key="fcnt_result.submissions.last" var="submissionsLast"/>
<fmt:message key="fcnt_result.formField" var="fieldHeader"/>
<fmt:message key="fcnt_result.dashboard.empty.percent" var="percentageHeader"/>
<template:addResources type="inlinejavascript">
    <script>
        var graphResultsView;
        var jsVarMap;
        $(document).ready(function(){
            $(".datepickers").datepicker({
                format: 'dd/mm/yyyy',
                todayBtn: true,
                language: '${renderContext.UILocale}',
                calendarWeeks: true,
                autoclose: true
            });

            var totalView = new TotalAverageView();
            graphData = new Dashboard();
            graphData.formId=selectedResult;
            graphData.site="${renderContext.site.name}";
            graphData.steps=5;
            graphData.patternMap = [
                {serverPattern:"YYYY",displayPattern:"YYYY"},
                {serverPattern:"YYYYMM",displayPattern:"MM/YYYY"},
                {serverPattern:"YYYYww",displayPattern:"YYYY : Wo"},
                {serverPattern:"YYYYMMdd",displayPattern:"DD/MM/YYYY"}
            ];


            //Render reports calling backbone views
            timeSubmissionView = new TimeSubmissionView({
                model:graphData,
                lineGraphEl:$("#lineChart"),
                parameters : [{name:"group_by",values:["month"]},{name:"fromDate",values :[]},{name:"toDate",values :[]}],
                legends:[{name:"day",value:"<fmt:message key='fcnt_result.daily'/>"},{name:"week",value:"<fmt:message key='fcnt_result.weekly'/>"},{name:"month",value:"<fmt:message key='fcnt_result.monthly'/>"},{name:"year",value:"<fmt:message key='fcnt_result.annual'/>"},]
            });
            pageSubmissionView = new PageSubmissionView({
                model:graphData,
                barGraphEl:$("#barChart"),
                parameters : [{name:"group_by",values:["origin","month"]},{name:"fromDate",values :[]},{name:"toDate",values :[]}]
            });
            emptySubmissionView = new EmptySubmissionView({
                model:graphData,
                tableEl:$("#emptyFields"),
                parameters : [{name:"group_by",values:["origin","month"]},{name:"fromDate",values :[]},{name:"toDate",values :[]}],
                datatableTitles:["${functions:escapeJavaScript(fieldHeader)}","${functions:escapeJavaScript(percentageHeader)}"],
                noResultLabel:"<fmt:message key="fcnt.dataTableNoResult"/>"
            });
            choiceFieldView = new ChoiceFieldView({
                model:graphData,
                pieGraphEl:$("#pieChart"),
                parameters : [{name:"group_by",values:["origin","month"]},{name:"fromDate",values :[]},{name:"toDate",values :[]}]
            });
        });
    </script>
</template:addResources>
<div class="row-fluid">
    <%@ include file="totalaverage.jspf" %>
    <div class="span8">
        <form id="datePicker" class="form-inline">
            <fieldset>
                <legend><fmt:message key="fcnt_result.datePicker.legend"/></legend>
                <div class="input-append date datepickers" style="vertical-align: top">
                    <input type="text" name="from" value=""
                           placeholder="<fmt:message key="fcnt_result.datePicker.from"/>"/>
                        <span class="add-on">
                            <i class="icon-calendar"></i> <fmt:message key="fcnt_result.datePicker.fromHour"/>
                        </span>
                </div>
                <div class="input-append date datepickers" style="vertical-align: top">
                    <input type="text" name="to" value="" placeholder="<fmt:message key="fcnt_result.datePicker.to"/>"/>
                        <span class="add-on">
                            <i class="icon-calendar"></i> <fmt:message key="fcnt_result.datePicker.toHour"/>
                        </span>
                </div>
                <button type="button" class="btn btn-primary" onclick="filterGraphResults(graphData)">
                    <fmt:message key="fcnt_result.filter"/>
                </button>
            </fieldset>
        </form>
    </div>
</div>

<h2><fmt:message key="fcnt_result.dashboard.reports.global"/></h2>
<hr />
<div class="row-fluid">
    <div id="lineChart" class="span6">
        <div class="row-fluid">
            <div class="span6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.submitsOverTime"/></h5>
            </div>
            <div class="span6">
                <h5>
                    <select name="timeFilter" class="timeFilter" onchange="setTimeParameter(timeSubmissionView,$(this))">
                        <option value="day"><fmt:message key="fcnt_result.dashboard.selector.days"/></option>
                        <option value="week"><fmt:message key="fcnt_result.dashboard.selector.weeks"/></option>
                        <option value="month" selected="selected"><fmt:message key="fcnt_result.dashboard.selector.months"/></option>
                        <option value="year"><fmt:message key="fcnt_result.dashboard.selector.years"/></option>
                    </select>
                </h5>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <div class="message box-1">
                    <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                </div>
                <canvas id="countChart" width="500" height="200"></canvas>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <div id="countChart_legend" class="chart_legend"></div>
            </div>
        </div>
    </div>

    <div id="barChart" class="span6">
        <div class="row-fluid">
            <div class="span6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.perPage"/></h5>
            </div>
            <div class="span6">
                <h5>
                    <select name="timeFilter" class="timeFilter" onchange="setTimeParameter(pageSubmissionView,$(this))">
                        <option value="day"><fmt:message key="fcnt_result.dashboard.selector.days"/></option>
                        <option value="week"><fmt:message key="fcnt_result.dashboard.selector.weeks"/></option>
                        <option value="month" selected="selected"><fmt:message key="fcnt_result.dashboard.selector.months"/></option>
                        <option value="year"><fmt:message key="fcnt_result.dashboard.selector.years"/></option>
                    </select>
                </h5>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <div class="message box-1">
                    <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                </div>
                <canvas width="500" height="200"></canvas>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <div class="chart_legend"></div>
            </div>
        </div>
    </div>
</div>
<hr />
<div class="row-fluid">
    <div id="dataTable" class="span6">
        <h5><fmt:message key="fcnt_result.dashboard.reports.empty"/></h5>
        <table class="table table-striped table-bordered" id="emptyFields"></table>
    </div>

    <div id="pieChart" class="span6">
        <div class="row-fluid">
            <div class="span6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.choice"/></h5>
            </div>
            <div class="span6">
                <h5>
                    <select name="choiceField"></select>
                </h5>
            </div>
        </div>
            <div class="row-fluid">
                <div class="span12">
                    <div class="message box-1">
                        <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                    </div>
                    <canvas id="choiceChart" width="500" height="200"></canvas>
                </div>
            </div>
            <div class="row-fluid">
                <div class="span12">
                    <div id="choiceChart_legend" class="chart_legend"></div>
                </div>
            </div>
    </div>
</div>
