<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="css" resources="datepicker.css"/>
<template:addResources type="css" resources="custom.css"/>
<template:addResources type="css" resources="languageSwitchingLinks.css"/>
<template:addResources type="javascript" resources="lib/bootstrap-datepicker.js, lib/bootstrap-datepicker.${renderContext.UILocale}.js"/>
<template:addResources type="javascript" resources="fcResultsUtils.js"/>
<template:addResources type="javascript" resources="collections/results.js"/>
<template:addResources type="javascript" resources="lib/backbone.paginator.min.js"/>
<%--<template:addResources type="javascript" resources="lib/socket.io.js, lib/backbone.iobind.js,lib/backbone.iosync.js"/>--%>
<template:addResources type="javascript" resources="main-results.js"/>

<fmt:message key="fcnt.dataTableNoResult" var="dataTableNoResult"/>
<fmt:message key="fcnt_result.username" var="usernameHeader"/>
<fmt:message key="fcnt_result.submissionDate" var="subDateHeader"/>
<fmt:message key="fcnt_result.origin" var="originHeader"/>
<fmt:message key="fcnt_result.submissions.total" var="submissionsTotal"/>
<fmt:message key="fcnt_result.submissions.average" var="submissionsAverage"/>
<fmt:message key="fcnt_result.submissions.last" var="submissionsLast"/>
<fmt:message key="label.days" var="labelDays"/>
<fmt:message key="label.week" var="labelWeek"/>
<fmt:message key="label.month" var="labelMonth"/>
<fmt:message key="label.year" var="labelYear"/>

<template:addResources type="inlinejavascript">
    <script>

        var jsVarMap = {
            dataTableNoResult: '${functions:escapeJavaScript(dataTableNoResult)}',
            usernameHeader: '${functions:escapeJavaScript(usernameHeader)}',
            subDateHeader: '${functions:escapeJavaScript(subDateHeader)}',
            originHeader: '${functions:escapeJavaScript(originHeader)}',
            submissionsTotal: '${functions:escapeJavaScript(submissionsTotal)}',
            submissionsAverage: '${functions:escapeJavaScript(submissionsAverage)}',
            submissionsLast: '${functions:escapeJavaScript(submissionsLast)}',
            labelDays: '${functions:escapeJavaScript(labelDays)}',
            labelWeek: '${functions:escapeJavaScript(labelWeek)}',
            labelMonth: '${functions:escapeJavaScript(labelMonth)}',
            labelYear: '${functions:escapeJavaScript(labelYear)}',
            buttonsUrl : "<c:url value='${url.currentModule}/swf/copy_csv_xls_pdf.swf' />"
        };
        labels = [];
        labels.push({label: jsVarMap.usernameHeader, htmlId: 'username'}, {label: jsVarMap.subDateHeader, htmlId: 'submissionDate'}, {label: jsVarMap.originHeader, htmlId: 'origin'});

        var API_URL = '${url.context}/modules/formfactory/results/${currentResource.locale}';

        // Initializing backbone objects
        // Initializing backbone objects
        /*var dataCollection = new ResultsCollection();*/
        var dataCollection = new PageableResults();
        dataCollection.site = "${renderContext.site.name}";
        dataCollection.formId = selectedResult;

        var _checkboxesTemplate = _.template("<label class='checkbox span2 checkboxRemover'>" +
                "<input type='checkbox' class='popoverPicker' value='<@= htmlId @>' onchange='" +
                "fnShowHide(<@= key @>)' <@ if(isChecked) { @> checked <@ } @> />" +
                "<@= (label)?label:htmlId @>" +
                "</label>");

        $(document).ready(function () {
            // Initialize date pickers
            $(".datepickers").datepicker({
                format: 'dd/mm/yyyy',
                todayBtn: true,
                language: '${renderContext.UILocale}',
                calendarWeeks: true,
                autoclose: true
            });
            // Creating results Backbone view now the page is loaded
            /*var dataCollectionView = new DatatableResultsView({collection: dataCollection});*/
            var dataCollectionView = new PageableResultsView({
                collection: dataCollection,
                grid_el: $("#formDataTable"),
                searchLabel:"<fmt:message key="label.search"/>",
                resultsFromLabel:"<fmt:message key="fcnt_result.resultsFrom"/>",
                resultsToLabel:"<fmt:message key="fcnt_result.resultsTo"/>",
                noResultLabel:"<fmt:message key="fcnt.dataTableNoResult"/>",
                exportLabel:"<fmt:message key="label.export"/>",
                copyLabel:"<fmt:message key="label.copy"/>",
                printLabel:"<fmt:message key="label.print"/>",
                swfUrl:"${url.context}"+urlCurrentModule + "/swf/copy_csv_xls_pdf.swf",
                printToolTipText:"<fmt:message key="fcnt_result.datatable.print.tooltipText"/>",
                printInfoText:"<fmt:message key="fcnt_result.datatable.print.infoText"/>"
            });
            dataCollection.fromDate = new Date(formModel.get("created")).getTime();
            new TotalAverageView({collection: dataCollection});
            var lastScroll = 0;
            $("#formDataTable_wrapper .dataTables_scrollBody").scroll(function(options){
                var scrollBody = $(options.currentTarget);
                var scrollTop = scrollBody.scrollTop();
                var scrollHeight = scrollBody.prop('scrollHeight');
                var scrollPercent = Math.round((scrollTop*100)/(scrollHeight-200));

                if(scrollPercent>=60 && scrollPercent>lastScroll && !dataCollection.fetchingPage){
                    dataCollection.fetchingPage=true;
                    dataCollection.getNextPage({
                        success:function(){
                            dataCollection.fetchingPage=false;
                        }
                    });
                }
                lastScroll=scrollPercent;
            });
            // Getting data and updating the view
            dataCollection.fetchingPage = true;
            dataCollection.getFirstPage({success: function () {
                dataCollection.fetchingPage = false;
            }
            });
            $("#columnPicker").click(function (){
                $("#columnschoice").toggle();
            })
        });
    </script>
</template:addResources>

<div class="row-fluid">
    <%@ include file="totalaverage.jspf" %>
    <div class="span8">
        <form id="datePicker" class="form-inline">
            <fieldset>
                <legend><fmt:message key="fcnt_result.datePicker.legend"/></legend>
                <div class="input-append date datepickers" style="vertical-align: top">
                    <input type="text" name="from" value=""
                           placeholder="<fmt:message key="fcnt_result.datePicker.from"/>"/>
                    <span class="add-on">
                        <i class="icon-calendar"></i> <fmt:message key="fcnt_result.datePicker.fromHour"/>
                    </span>
                </div>
                <div class="input-append date datepickers" style="vertical-align: top">
                    <input type="text" name="to" value="" placeholder="<fmt:message key="fcnt_result.datePicker.to"/>"/>
                    <span class="add-on">
                        <i class="icon-calendar"></i> <fmt:message key="fcnt_result.datePicker.toHour"/>
                    </span>
                </div>
                <button type="button" class="btn btn-primary" onclick="filterResults()">
                    <fmt:message key="fcnt_result.filter"/>
                </button>
            </fieldset>
        </form>
    </div>
</div>

<div class="row-fluid">
    <div class="span12 alert alert-info">
        <form id="columnPicker">
            <fieldset>
                <legend><fmt:message key="fcnt_result.columnPicker.legend"/></legend>
                <div id="columnschoice" style="display: none">

                </div>
            </fieldset>
        </form>
    </div>
</div>

<div id="dataTable" class="row-fluid">
    <table class="table table-striped table-bordered" id="formDataTable">
        <thead>
        <tr id="dataHeaders"></tr>
        </thead>
        <tbody id="dataBody"></tbody>
    </table>
</div>