function callWorkInProgress(){
    if( $.browser.msie == true){
        $.blockUI({ css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }, message: jsVarMap.i18nWaiting });
    } else {
        workInProgress(jsVarMap.i18nWaiting);
    }
}

/**
 * This function clone the form in the new displayed step
 * @param newStep : the last step activate by the user
 */
function saveAndLoadFormInSteps (newStep) {
    var oldStep = currentStep;

    //Saving the current Form in stepsTable
    if (currentStep == "stepAction") {
        stepAction.stepActionContent = formView.collection.toJSON();
    } else {
        stepsTable[oldStep].stepContent = formView.collection.toJSON();
    }

    //Changing current Step
    currentStep = newStep;

    //Loading the form step in the form view
    formView.collection.reset();
    if (currentStep == "stepAction") {
        $("#btnDeleteStep").attr("disabled", "disabled");
        if (stepAction.stepActionContent.length > 0) {
            formView.collection.add(stepAction.stepActionContent);
        } else {
            formView.collection.cleanView();
        }
        $("#step" + oldStep + "Content").attr("id", "stepActionContent");
    } else {
        $("#btnDeleteStep").removeAttr("disabled");
        if (stepsTable[currentStep].stepContent.length > 0) {
            formView.collection.add(stepsTable[currentStep].stepContent);
        }
        else {
            formView.collection.cleanView();
        }
        //Updating tabContent Id to Match
        $("#step" + oldStep + "Content").attr("id", "step" + currentStep + "Content");
    }
//    activateDesactivateBtnIfModifications(_.isEqual(formWithoutModification, formJson));
}

/**
 * This function decrease the steps number and load the eventId will be submitted
 */
function stepMinus() {
    var $formStepsNumber = $("#formStepsNumber");
    var intValue = parseInt($formStepsNumber.val());
    intValue--;
    $formStepsNumber.val(intValue);
    $("#currentStep").val(currentStep);
    if (intValue == 1) {
        $("#minusButton").attr("disabled", "disabled");
    }
    submitSteps();
}

/**
 * This function increase the steps number and load the eventId will be submitted
 */
function stepPlus() {
    var $formStepsNumber = $("#formStepsNumber");
    var intValue = parseInt($formStepsNumber.val());
    intValue++;
    $formStepsNumber.val(intValue);
    $("#currentStep").val(intValue - 1);
    if (intValue == 2) {
        $("#minusButton").removeAttr("disabled");
    }
    submitSteps();
}

/**
 * This function submit to the FlowHandler the new steps number
 */
function submitSteps() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_submitSteps");
    saveForm();
    $(".currentFormManagement").submit();
}

/**
 * This function save the form and submit to the FlowHandler if valid return true
 */
function submitCreatedForm() {
    saveForm();
    if (validForm()) {
        callWorkInProgress();
        if (currentStep == "stepAction") {
            $("#currentStep").val(0);
        } else {
            $("#currentStep").val(currentStep);
        }
        //Setting the good Webflow event
        $("#eventInput").attr("name", "_eventId_saveForm");
        $(".currentFormManagement").submit();
    }
}

/**
 * This function save the current step and the form in the variable formJson
 */
function saveForm() {
    //Saving the current Form in stepsTable
    if (currentStep == "stepAction") {
        stepAction.stepActionContent = formView.collection.toJSON();
        formJson.formStepAction = stepAction;
    } else {
        stepsTable[currentStep].stepContent = formView.collection.toJSON();
        formJson.formSteps = stepsTable;
        formJson.formStepsNumber = stepsTable.length;
    }
    //Converting to Json String
    var jsonString = JSON.stringify(formJson);
    $("#formNewJson").val(jsonString);
}

/**
 * This function valid the form before saving
 * @returns {boolean}
 */
function validForm() {
    var boolean = true;

    if (stepAction.stepActionContent == "") {
        bootbox.alert('<span class="text-error">' + jsVarMap.titleErrorWhenSavingForm.toUpperCase() + ' !</span><br /><br />' + jsVarMap.modalErrorWhenSavingFormNoAction, function(){});
        return false
    }

    if (!checkDoubleIDInForm()){
        return false;
    }

    return boolean;
}

/**
 * this function check if the form you want to submit contains double ID or not
 * @returns {boolean}
 */
function checkDoubleIDInForm() {
    // Generate object with all the id and their position
    var inputIds = {};
    _.each(stepsTable, function(step){
        var currentStep = step.stepNumber + 1;
        _.each(step.stepContent, function(snippet, index){
            var snippetPOS = index + 1;
            var idValue = snippet.fields.id.value;
            if (!_.has(inputIds, idValue)) {
                inputIds[idValue] = {};
                inputIds[idValue][currentStep] = [];
            }
            else if (!_.has(inputIds[idValue], currentStep)){
                inputIds[idValue][currentStep] = [];
            }
            inputIds[idValue][currentStep].push(snippetPOS);
        });
    });
    var duplicateIds = {};
    _.filter(inputIds,function(e,key){
        if(_.size(e)>1) {
            duplicateIds[key] = e;
            return false;
        }
    });

    if (_.size(duplicateIds) > 0) {
        bootbox.alert(modalTemplate({inputId: duplicateIds}), function(){});
        return false;
    } else {
        return true;
    }
}

/**
 * This function display a modal to confirm the action to reset the Form Builder UI
 */
function bbResetForm(){
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleClearFormConfirmation + "<h3>",
        message: "<p>" + jsVarMap.modalClearFormConfirmation + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelNo,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelYes,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    resetForm();
                }
            }
        }
    });
}

/**
 * This function submit to the FlowHandler the action reset form to reset the UI
 */
function resetForm() {
    $("#eventInput").attr("name", "_eventId_resetForm");
    $(".currentFormManagement").submit();
    blockInfoPopupOnSectionChange = true;
}

/**
 * This function display a modal to confirm The action engaged by the user.
 */
function bbChangeSection(section) {
    if(blockInfoPopupOnSectionChange) {
        if (section == 'Library') {
            backToLibraryWithoutSaving();
        } else {
            $("#eventInput").attr("name", "_eventId_goToMetaDataEditorWithoutSaving");
            $(".currentFormManagement").submit();
        }
        return;
    }
    var bbMessage;
    var bbBtnNoSave;
    var bbBtnSave;
    if (section == 'Library') {
        bbMessage = jsVarMap.modalBackToLibrary;
        bbBtnNoSave = jsVarMap.buttonBackWithoutSaving;
        bbBtnSave = jsVarMap.buttonSaveAndBack;
    } else {
        bbMessage = jsVarMap.modalGoToMetaDataEditor;
        bbBtnNoSave = jsVarMap.buttonGoWithoutSaving;
        bbBtnSave = jsVarMap.buttonSaveAndGo;
    }
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleQuitFormCenterBuilder + "<h3>",
        message: "<p>" + bbMessage + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelCancel,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: bbBtnNoSave,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    if (section == 'Library') {
                        backToLibraryWithoutSaving();
                    } else {
                        $("#eventInput").attr("name", "_eventId_goToMetaDataEditorWithoutSaving");
                        $(".currentFormManagement").submit();
                    }
                }
            },
            main: {
                label: bbBtnSave,
                className: "btn-primary",
                callback: function() {
                    saveForm();
                    if (validForm()) {
                        callWorkInProgress();
                        if (section == 'Library') {
                            //Setting the good Webflow event
                            $("#eventInput").attr("name", "_eventId_saveAndBackToLibrary");
                            $(".currentFormManagement").submit();
                        } else {
                            //Setting the good Webflow event
                            $("#eventInput").attr("name", "_eventId_saveAndGoToMetaDataEditor");
                            $(".currentFormManagement").submit();
                        }
                    }
                }
            }
        }
    });
}

/**
 * This function submit to the FlowHandler the action to back to the library
 * without saving the current form
 */
function backToLibraryWithoutSaving() {
    $("#eventInput").attr("name", "_eventId_backToLibraryWithoutSaving");
    $(".currentFormManagement").submit();
}

/**
 * This function display a modal to confirm the action to delete the step
 */
function bbDeleteCurrentStep() {
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleDeleteFormStepConfirmation + " : " + (parseInt(currentStep) + 1) + "<h3>",
        message: "<p>" + jsVarMap.modalDeleteFormStepConfirmation + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelNo,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelYes,
                className: "btn-danger",
                callback: function() {
                    stepMinus();
                }
            }
        }
    });
}

function activateDesactivateBtnIfModifications(equals) {
    if (equals) {
        $("#btnBackToLibrary").attr("onclick", "backToLibraryWithoutSaving()");
        $("#btnSaveForm").attr("disabled", "disabled");
        $("#btnResetForm").attr("disabled", "disabled");
    } else {
        $("#btnBackToLibrary").attr("onclick", "bbBackToLibrary()");
        $("#btnSaveForm").removeAttr("disabled");
        $("#btnResetForm").removeAttr("disabled");
    }
}