$(document).ready(function () {
    // Data Table initialization
    $('#myFormsDataTable').dataTable({
        "sDom": "<'row-fluid'<'span6'l><'span6'f>r>t<'row-fluid'<'span6'i><'span6'p>>",
        "iDisplayLength": 10,
        "sPaginationType": "bootstrap",
        "aaSorting": [], //this option disable sort by default, the user steal can use column names to sort the table
        "oLanguage": {
            "sEmptyTable": jsVarMap.dataTableNoResult
        }
    });
    $(".timeago").each(function(index, element){
        var timeago = $(element);
        var time = moment(timeago.html(), moment.ISO_8601);
        timeago.html(time.calendar());
    });
});

/**
 * This function check if the name choose by the user is available
 */
function checkFormNameAvailableInJCR(nameNewForm) {
    $('#createNewForm').attr('disabled','disabled');
    // Test only if not empty
    if (nameNewForm != '') {
        var errorDiv = '#error_nameNewFormAvailability';
        $.ajax({
            url : jsVarMap.checkFormNameURL,
            type : 'POST',
            data : { formName: nameNewForm, site: jsVarMap.siteName, currentFormJCRId: "" },
            dataType : 'json',
            success : function(data) {
                if(data['result'] != 'success')
                {
                    $(errorDiv).html(data['errorMessage']);
                    $(errorDiv).show();
                }
                else{
                    $(errorDiv).hide();
                    $('#nameNewForm').val(nameNewForm);
                    $('#createNewForm').removeAttr('disabled');
                }
            },
            error : function(){
                $(errorDiv).html(jsVarMap.errorFormNameImpossibleToCheck);
                $(errorDiv).show();
            }
        });
    }
}

function callWorkInProgress(){
    if($.browser.msie == true){
        $.blockUI({ css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }, message: jsVarMap.i18nWaiting });
    } else {
        workInProgress(jsVarMap.i18nWaiting);
    }
}

function submitNewForm() {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_newForm");
    $(".manageForms").submit();
}

/**
 * This function display a modal to name the form you want to create
 * and submit to the FlowHandler the form who will be use as template
 * @param id : JCR ID of the form you want to delete
 */
function bbUseAsTemplate(id, formNameToUse) {
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleNameNewFormTemplate + " : " + formNameToUse + "<h3>",
        message: "<p>" + jsVarMap.modalNameNewFormTemplate +
            "</p><input id='nameNewFormInput' type='text' data-form-jcrID='" + id + "'>" +
            "<div class='hide text-error error_nameFormAvailability'></div>" +
            "<script>$('.nameButton').attr('disabled', 'disabled');" +
            "var timeoutReference;" +
            "$('#nameNewFormInput').keypress(function() {" +
                "var _this = $(this);" +
                "if (timeoutReference) clearTimeout(timeoutReference);" +
                "timeoutReference = setTimeout(function() {" +
                    "checkFormNameAvailableToUseAsTemplate(_this.val(), _this.data('form-jcrID'));" +
                "}, 1000);" +
            "});" +
            "</script>",
        buttons: {
            danger: {
                label: jsVarMap.labelCancel,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelOk,
                className: "btn-primary nameButton",
                callback: function() {
                    callWorkInProgress();
                    $("#nameNewForm").val($("#nameNewFormInput").val());
                    $("#eventInput").attr("name", "_eventId_useAsTemplate");
                    $("#selectedForm").val(id);
                    $(".manageForms").submit();
                }
            }
        }
    });
}

function bbDuplicateUseAsTemplate(id, formNameToUse) {
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleNameNewFormTemplate + " : " + formNameToUse + "<h3>",
        message: "<p>" + jsVarMap.modalNameNewFormTemplate +
            "</p><input id='nameNewFormInput' type='text' data-form-jcrID='" + id + "'>" +
            "<div class='hide text-error error_nameFormAvailability'></div>" +
            "<script>$('.nameButton').attr('disabled', 'disabled');" +
            "var timeoutReference;" +
            "$('#nameNewFormInput').keypress(function() {" +
                "var _this = $(this);" +
                "if (timeoutReference) clearTimeout(timeoutReference);" +
                "timeoutReference = setTimeout(function() {" +
                    "checkFormNameAvailableToUseAsTemplate(_this.val(), _this.data('form-jcrID'));" +
                "}, 1000);" +
            "});" +
            "</script>",
        buttons: {
            danger: {
                label: jsVarMap.labelCancel,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelOk,
                className: "btn-primary nameButton",
                callback: function() {
                    callWorkInProgress();
                    $("#nameNewForm").val($("#nameNewFormInput").val());
                    $("#eventInput").attr("name", "_eventId_duplicateUseAsTemplate");
                    $("#selectedForm").val(id);
                    $(".manageForms").submit();
                }
            }
        }
    });
}

/**
 * This function submit to the FlowHandler the Selected Form you want to modify
 * @param id : JCR ID of the selected form
 */
function loadFormToUpdate(id) {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_loadForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();
}

function loadFormToTranslate(id) {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_loadFormForTranslation");
    $("#selectedForm").val(id);
    $(".manageForms").submit();
}

function loadFormToEditMetaData(id) {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_loadFormToEditMetaData");
    $("#selectedForm").val(id);
    $(".manageForms").submit();
}

function publishForm(id) {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_publishForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();
}

function startWorkflowOnForm(id) {
    callWorkInProgress();
    $("#eventInput").attr("name", "_eventId_startWorkflowOnForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();
}

/**
 * This function display a modal to confirm the action to delete the form
 * @param id : JCR ID of the form you want to delete
 */
function bbDeleteForm(id, nameFormToDelete){
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleDeleteConfirmation + " : " + nameFormToDelete + "<h3>",
        message: "<p>" + jsVarMap.modalDeleteConfirmation + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelNo,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelYes,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    submitDeleteForm(id);
                }
            }
        }
    });
}

function bbMarkToDeleteForm(id, nameFormToDelete){
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleDeleteConfirmation + " : " + nameFormToDelete + "<h3>",
        message: "<p>" + jsVarMap.modalDeleteConfirmation + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelNo,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelYes,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    submitMarkToDeleteForm(id);
                }
            }
        }
    });
}

function bbUndeleteForm(id, nameFormToDelete){
    bootbox.dialog({
        title: "<h3>" + jsVarMap.titleUndeleteConfirmation + " : " + nameFormToDelete + "<h3>",
        message: "<p>" + jsVarMap.modalUndeleteConfirmation + "</p>",
        buttons: {
            danger: {
                label: jsVarMap.labelNo,
                className: "btn-default",
                callback: function() {}
            },
            success: {
                label: jsVarMap.labelYes,
                className: "btn-danger",
                callback: function() {
                    callWorkInProgress();
                    submitUndeleteForm(id);
                }
            }
        }
    });
}

/**
 * This function submit to the FlowHandler the form who will be deleted
 * @param id : JCR ID of the form you want to delete
 */
function submitMarkToDeleteForm(id) {
    $("#eventInput").attr("name", "_eventId_deleteForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();

}

function submitDeleteForm(id) {
    $("#eventInput").attr("name", "_eventId_reallyDeleteForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();

}

function submitUndeleteForm(id) {
    $("#eventInput").attr("name", "_eventId_undeleteForm");
    $("#selectedForm").val(id);
    $(".manageForms").submit();

}

/**
 * !!! *** This function is call in a template so Intellij think it's not use *** !!!
 * This function check if the name choose by the user is available for the rename or UseAsTemplate
 * @param nameForm : the name you want to check
 * @param currentFormID : JCR ID of the current form (needed only for rename)
 */
function checkFormNameAvailableToUseAsTemplate(nameForm, currentFormID){
    $('.nameButton').attr('disabled','disabled');
    // Test only if not empty
    if (nameForm != '') {
        var errorDiv = '.error_nameFormAvailability';
        $.ajax({
            url : jsVarMap.checkFormNameURL,
            type : 'POST',
            data : { formName: nameForm, site: jsVarMap.siteName, currentFormJCRId: currentFormID },
            dataType : 'json',
            success : function(data) {
                if(data['result'] != 'success')
                {
                    $(errorDiv).html(data['errorMessage']);
                    $(errorDiv).show();
                }
                else{
                    $(errorDiv).hide();
                    $('.nameButton').removeAttr('disabled');
                }
            },
            error : function(){
                $(errorDiv).html(jsVarMap.errorFormNameImpossibleToCheck);
                $(errorDiv).show();
            }
        });
    }
}