define([
    'jquery', 'underscore', 'backbone'
], function ($, _, Backbone) {
    return Backbone.Model.extend({
        url:postUrl,
        validation : function() {
            if(formValidation != undefined) {
                return formValidation[currentStep];
            } else {
                return false;
            }
        },
        sync:function(method,model,options){
            if(formValidation != undefined) {
                /**
                 * Overwriting the Backbone.js Sync function to send a request catchable by webflow
                 * @type {{create: string, update: string, delete: string, read: string}}
                 */
                var modelData = model.toJSON();
                var webflowEvent;
                for (key in modelData) {
                    if (key.indexOf("_eventId_") >= 0) {
                        webflowEvent = key;
                    }
                }
                var $formFactoryTarget = $('#formFactoryTarget');
                $formFactoryTarget.append("<input type='hidden' name='formData' class='formDataHidden'/>");
                $formFactoryTarget.find('.formDataHidden').val(modelData.formData);
                $formFactoryTarget.append("<input type='hidden' name='" + webflowEvent + "'/>");
                $formFactoryTarget.append("<input type='submit' name='Submit' style='display: none' id='formFactoryTargetSubmitButton'/>");
                return $('#formFactoryTargetSubmitButton').click();
            }
        }
    });
});
