$(document).ready(function () {
    $('#formFactoryBuild').on('popover_show', function () {
        $('#typeaheadDiv').find('.typeahead').each(function (index, element) {
            $(element).typeahead('destroy');
            $(element).typeahead({hint: true, highlight: true, minLength: 2},
                {
                    name: $(element).data('typeaheadname'),
                    displayKey: $(element).data('typeaheaddisplaykey'),
                    source: window[$(element).data("typeaheadsource")](element)
                }).on('typeahead:selected', function (event, data) {
                    $('#typeaheadDiv').find('.field').val(data.value);
                });
        });
        var selectedPageId = $('#selectedPageValue').attr('pagevalue');
        $('#treePage').jstree({
            core: {
                animation: 0,
                check_callback: true,
                themes: {
                    name: 'proton',
                    responsive: true
                },
                plugins: ['wholerow', 'checkbox'],
                data: {
                    url: function (node) {
                        return node.id === '#' ?
                            API_URL_START + rootNode :
                            API_URL_START + node.id;
                    },
                    convert: function (node) {
                        var childrens = [];
                        var i = 0;
                        $.each(node.children, function (idx, elt) {
                            if (elt.type == 'jnt:page') {
                                if (selectedPageId !== '') {
                                    childrens[i++] = {id: elt.id,
                                        text: elt.name,
                                        children: true,
                                        state: {opened: true, undetermined: true},
                                        icon: jsVarMap.context + '/modules/assets/icons/jnt_page.png'
                                    };
                                }
                                else {
                                    childrens[i++] = {id: elt.id,
                                        text: elt.name,
                                        children: true,
                                        state: {opened: false, undetermined: true},
                                        icon: jsVarMap.context + '/modules/assets/icons/jnt_page.png'
                                    };
                                }
                            }
                        });
                        return {id: node.id,
                            text: node.name,
                            children: childrens,
                            state: {opened: true, undetermined: true},
                            icon: jsVarMap.context + '/modules/assets/icons/jnt_page.png'};
                    }
                }
            }}).on('select_node.jstree', function (event, selected) {
                var typeaheadDiv = $('#typeaheadDiv');
                typeaheadDiv.find('.field').val(selected.node.id);
                typeaheadDiv.find('.input-large').val(selected.node.text);
                $('#selectedPageName').html(selected.node.text);
        }).on('ready.jstree', function() {
            if (selectedPageId !== '') {
                setTimeout(function() {
                    if ($('#treePage').length > 0) {
                        $('#treePage').jstree(true).select_node(selectedPageId);
                        var name = $('#' + selectedPageId + '_anchor').html().trim();
                        $('#selectedPageName').html(name);
                    }
                }, 350);
            }
        });

        var typeaheadDiv = $('#typeaheadDiv');
        typeaheadDiv.find('.input-large').on('keydown', function(){
            $('#treePage').hide();
        });
    });
});
